TrackWarningWindow = class(Turbine.UI.Window);
 
function TrackWarningWindow:Constructor()

  Turbine.UI.Window.Constructor(self);
  local width = 400;
  local height = 90;
	self:SetSize(width,height);
  self:SetPosition(data.numbers.trackWarning_x,data.numbers.trackWarning_y);

  self:SetWantsKeyEvents(true);
  self:SetMouseVisible(false);
  self:SetVisible(true);
  
 	self.track_warning_label = Turbine.UI.Label();
  self.track_warning_label:SetParent(self);
  self.track_warning_label:SetSize(width,height - 20);
  self.track_warning_label:SetForeColor(Turbine.UI.Color(255/255,50/255,50/255));
	self.track_warning_label:SetPosition(0,20);
	self.track_warning_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.track_warning_label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold30);
	self.track_warning_label:SetFontStyle(Turbine.UI.FontStyle.Outline);
  self.track_warning_label:SetText(L.Track);
	self.track_warning_label:SetMouseVisible(false);
  self.track_warning_label:SetVisible(false);
 
  self.MovePanel = Turbine.UI.Control();
  self.MovePanel:SetParent(self);
  self.MovePanel:SetSize(2000,20);
  self.MovePanel:SetBackground("PvMP_Plus/Resources/dragbar.tga");

  self.MoveText = Turbine.UI.Label();
  self.MoveText:SetParent(self.MovePanel);
  self.MoveText:SetSize(width,12);
  self.MoveText:SetPosition(0,4);
  self.MoveText:SetFont(Turbine.UI.Lotro.Font.Verdana12);
  self.MoveText:SetText("PvMP+ Track Warning");
	self.MoveText:SetFontStyle(Turbine.UI.FontStyle.Outline);
  self.MoveText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.MoveText:SetMouseVisible(false);
	
	-- REPOSITIONING --
  -- shadow box
  self.shadowBox = Turbine.UI.Window();
  self.shadowBox:SetParent(self);
  self.shadowBox:SetPosition(0, 20);
	self.shadowBox:SetSize(width, height);
  self.shadowBox:SetMouseVisible(false);
  self.shadowBox:SetVisible(false);
    
  -- top left corner
  self.shadowBox.topLeft = Turbine.UI.Control();
  self.shadowBox.topLeft:SetParent(self.shadowBox);
  self.shadowBox.topLeft:SetSize(10, 10);
  self.shadowBox.topLeft:SetPosition(0, 0);
  self.shadowBox.topLeft:SetMouseVisible(false);
  self.shadowBox.topLeft:SetBackground("PvMP_Plus/Resources/drag_topleft.tga");

  -- topRight
  self.shadowBox.topRight = Turbine.UI.Control();
  self.shadowBox.topRight:SetParent(self.shadowBox);
  self.shadowBox.topRight:SetSize(10, 10);
  self.shadowBox.topRight:SetPosition(width - 10, 0);
  self.shadowBox.topRight:SetMouseVisible(false);
  self.shadowBox.topRight:SetBackground("PvMP_Plus/Resources/drag_topright.tga");
    
  -- bottomLeft
  self.shadowBox.bottomLeft = Turbine.UI.Control();
  self.shadowBox.bottomLeft:SetParent(self.shadowBox);
  self.shadowBox.bottomLeft:SetSize(10, 10);
  self.shadowBox.bottomLeft:SetPosition(0, height - 30);
  self.shadowBox.bottomLeft:SetMouseVisible(false);
  self.shadowBox.bottomLeft:SetBackground("PvMP_Plus/Resources/drag_bottomleft.tga");

  -- bottomRight
  self.shadowBox.bottomRight = Turbine.UI.Control();
  self.shadowBox.bottomRight:SetParent(self.shadowBox);
  self.shadowBox.bottomRight:SetSize(10, 10);
  self.shadowBox.bottomRight:SetPosition(width - 10, height - 30);
  self.shadowBox.bottomRight:SetMouseVisible(false);
  self.shadowBox.bottomRight:SetBackground("PvMP_Plus/Resources/drag_bottomright.tga");

	-- top side
  self.shadowBox.top = Turbine.UI.Control();
  self.shadowBox.top:SetParent(self.shadowBox);
  self.shadowBox.top:SetSize(width - 20, 10);
  self.shadowBox.top:SetPosition(10, 0);
  self.shadowBox.top:SetMouseVisible(false);
  self.shadowBox.top:SetBackground("PvMP_Plus/Resources/drag_topmid.tga");

  -- left side
  self.shadowBox.left = Turbine.UI.Control();
  self.shadowBox.left:SetParent(self.shadowBox);
  self.shadowBox.left:SetSize(10, height - 40);
  self.shadowBox.left:SetPosition(0, 10);
  self.shadowBox.left:SetMouseVisible(false);
  self.shadowBox.left:SetBackground("PvMP_Plus/Resources/drag_midleft.tga");

  -- right side
  self.shadowBox.right = Turbine.UI.Control();
  self.shadowBox.right:SetParent(self.shadowBox);
  self.shadowBox.right:SetSize(10, height - 40);
  self.shadowBox.right:SetPosition(width - 10, 10);
  self.shadowBox.right:SetMouseVisible(false);
  self.shadowBox.right:SetBackground("PvMP_Plus/Resources/drag_midright.tga");

  -- bottom side
  self.shadowBox.bottom = Turbine.UI.Control();
  self.shadowBox.bottom:SetParent(self.shadowBox);
  self.shadowBox.bottom:SetSize(width - 20, 10);
  self.shadowBox.bottom:SetPosition(10, height - 30);
  self.shadowBox.bottom:SetMouseVisible(false);
  self.shadowBox.bottom:SetBackground("PvMP_Plus/Resources/drag_bottommid.tga");

  self.MovePanel:SetVisible(false);
 
  self.Moving = false;

  self.MovePanel.MouseDown = function(sender,args)
    self.MoveX = args.X;
    self.MoveY = args.Y;
    self.Moving = true;
    self.MovePanel:SetBackground("PvMP_Plus/Resources/dragbar_clicked.tga");
  end
    
  self.MovePanel.MouseUp = function(sender,args)
    self.Moving = false;
    self.MovePanel:SetBackground("PvMP_Plus/Resources/dragbar.tga");
  end
    
  self.MovePanel.MouseMove = function(sender,args)
    if self.Moving then
      local newLeft = self:GetLeft() - (self.MoveX - args.X);
      local newTop = self:GetTop() - (self.MoveY - args.Y);
      if newLeft < 0 then newLeft = 0 end;
      if newTop < 0 then newTop = 0 end;
      if newLeft > (Turbine.UI.Display.GetWidth() - self:GetWidth()) then
        newLeft = Turbine.UI.Display.GetWidth() - self:GetWidth() end;
      if newTop > (Turbine.UI.Display.GetHeight() - self:GetHeight()) then
        newTop = Turbine.UI.Display.GetHeight() - self:GetHeight() end;
			data.numbers.trackWarning_x = newLeft;
			data.numbers.trackWarning_y = newTop;
      self:SetPosition(data.numbers.trackWarning_x,data.numbers.trackWarning_y);
    end
  end

	self.MovePanel.MouseEnter = function(sender,args)
		self.shadowBox:SetVisible(true);
	end
		
	self.MovePanel.MouseLeave = function(sender,args)
		self.shadowBox:SetVisible(false);
	end
  
  self.KeyDown = function(sender,args) 
    if (args.Action == Turbine.UI.Lotro.Action.RepositionUI) then
      self.MovePanel:SetVisible(not self.MovePanel:IsVisible()); -- toggle visibility of MovePanel
    end
  end
  
end